<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#eze
# ***** END LICENSE BLOCK *****
#
# Contributor : Aurelien ANTOINE (http://ilpleut.be/)
#

$app_path = '/';
$blog_file_path = __FILE__;
$blog_dc_path = preg_replace("%[a-zA-Z0-9]+/[a-zA-Z0-9]+/[a-zA-Z0-9]+$%","",dirname(__FILE__));

require $blog_dc_path.'/inc/prepend.php';

$accept_xml =
	!empty($_SERVER['HTTP_ACCEPT']) &&
	strpos($_SERVER['HTTP_ACCEPT'],'application/xhtml+xml') !== false;

if (dc_send_real_xml && $accept_xml) {
	header('Content-Type: application/xhtml+xml');
} else {
	header('Content-Type: text/html; charset='.dc_encoding);
}

if ($accept_xml) {
	echo '<?xml version="1.0" encoding="'.dc_encoding.'"
  ?
  >'."\n";
}

echo
"<head>\n".
'  <title>DotClear - MailPost ver 0.2 </title>'."\n".
'  <style type="text/css">'."\n". 
'  @import "'.dc_app_url.'/ecrire/style/default.css"; '."\n".

"  </style>\n".
"</head>\n".
"<body>\n";

#mailpost class
require ("./inc/class.tools.php");
require ("./inc/mime/mimeDecode.php");

#download config file
$config_filename=DC_SHARE_DIR."/mailpost/config.php";
if (!file_exists($config_filename)) {
	echo "<h3>Le fichier de configuration est introuvable.</h3>";
	echo "<h3>The config file cannot be found.</h3>";
	die();
}
require($config_filename);

#load mail library
if ($mailpost_protocol=='soft') {
	include dirname(__FILE__)."/inc/class.mail.soft.php";
	$lk_mail= new ConnectionSoft($mailpost_server,$mailpost_protocol,$mailpost_login,$mailpost_passwd);
}else{
	include dirname(__FILE__)."/inc/class.mail.imap.php";
	$lk_mail= new ConnectionImap($mailpost_server,$mailpost_protocol,$mailpost_login,$mailpost_passwd);
}

#init tools
$convertion=(extension_loaded ('iconv'))?'iconv':"soft";
$encoding=(dc_encoding=='UTF-8')?"UTF-8":'ISO-8859-1';
$mp = new MPTools($encoding, $convertion, $mailpost_img_path, $mailpost_img_rel_path);

#get some dotclear info (cat/user...)
$blog_con = new connection(DB_USER,DB_PASS,DB_HOST,DB_DBASE);

if($blog_con->error()) {
	trigger_error('MySQL Error : '.$blog_con->error(),E_USER_ERROR);
	exit;
}

$blog = new blog($blog_con,DB_PREFIX,NULL,dc_encoding);

$cats=$blog->getCat();
foreach($cats->arry_data as $cat) {
	$cat_list[$mp->html2ascii($cat['cat_libelle'])]=$cat['cat_id'];
}

$users=$blog->getUser();
foreach($users->arry_data as $user) {
	# lignes ajoutes ou modifies par vincent jomain le 14/03/2006
        $user_list[$mp->html2ascii($user['user_id'])]=$user['user_id'];
        // pour que les noms d'utilisateurs correspondent  l'identifiant et pas au nom de famille
        //$user_list[$mp->html2ascii($user['user_nom'])]=$user['user_id'];
  # fin des lignes ajoutes ou modifies par vincent jomain le 14/03/2006
  

}
$langs=$blog->getPostLanguages();
foreach($langs->arry_data as $lang) {
	$lang_list[]=$lang['post_lang'];
}

#let's start
if ($lk_mail -> connect()) {
	echo "<h3>Connection etablie. ";
	$nbr_msg = $lk_mail -> get_ids();
	echo $nbr_msg." messages dans la boite.</h3>";
	if (count($lk_mail -> ids)>0) {
		foreach ($lk_mail -> ids as $mail_id) {
			echo "<h2>".$mail_id.") ";
			$params = array(
				'input'          => $lk_mail -> get($mail_id),
				'crlf'           => "\r\n",
				'include_bodies' => TRUE,
				'decode_headers' => TRUE,
				'decode_bodies'  => TRUE
			);
			$mail_no_delete=FALSE;
			$structure=Mail_mimeDecode::decode($params);
			
			$mp->init_mail_data();
			$mp->get_header_data($structure);
			$datemail=$mp->date;
			echo str_replace('<','&lt;',$mp->subject).' - '.date("H:i:s d/m/Y",$datemail).'</h2>';
			$mp->parse_tree($structure);
			$mp->htmlortxt();
			
			#create a md5 for this post
			$mail_md5=md5($mp->html_version.$mp->date.$mp->subject);
			
			#test if already inserted
			$strReq="SELECT post_id FROM ".$blog->t_post." WHERE post_notes = '".$mail_md5."'";
			if (($rs = $blog->con->select($strReq)) !== false) {
				if(! $rs->isEmpty()) {
					print "<h4>Ce billet est deja inser&eacute;</h4>";
					$mail_already_inserted=TRUE;
				}else{
					$mail_already_inserted=FALSE;
				}
			}else{
				die($blog->con->error());
			}
			
			#manage attached files
			if (count($mp->attached_file)>0) {
				echo '<h4>Fichier Attach&eacute;</h4><ul>';
				foreach($mp->attached_file as $af) {
					echo "<li>$af</li>";
				}
				echo "</ul>";
			}
			
			#manage inline image
			if (count($mp->inline_file)>0) {
				echo '<h4>Image dans le mail</h4><ul>';
				foreach($mp->inline_file as $af) {
					echo "<li>$af</li>";
				}
				echo "</ul>";
			}
			
			#split the mail in chapo/body/options
			$chapo='';
			$body='';
			$options='';
			#separate body from option
		
			$split_html=preg_split($mailpost_body_config,$mp->html_version,-1,PREG_SPLIT_NO_EMPTY);
      if(count($split_html)==2) {
				$options=trim($split_html[1]);
        # lignes ajoutes ou modifies par vincent jomain le 14/03/2006
        // pour que les options dans les mail en html soient purs des balises HTML
        $options= ereg_replace("<[^>]*>", "", $options);
        # fin des lignes ajoutes ou modifies par vincent jomain le 14/03/2006
        
        $body=trim($split_html[0]);
			}elseif(count($split_html)==1){
				$body=trim($split_html[0]);
        	
			}else{
				echo '<h3>Erreur dans la structure du mail (billet-config)</h3>';
				$mail_abort=TRUE;
			}	
      //echo 'Options: '.$options;
			#separate chapo from body
			$split_html=preg_split($mailpost_chapo_body,$body,-1,PREG_SPLIT_NO_EMPTY);
			if(count($split_html)==2) {
				$chapo=trim($split_html[0]);
				$body=trim($split_html[1]);
			}elseif(count($split_html)==1){
				$body=trim($split_html[0]);
			}else{
				echo '<h3>Erreur dans la structure du mail (chapo-billet)</h3>';
				$mail_abort=TRUE;
			}
			
			$chapo=$mp->check_image($chapo);
			$chapo=$mp->convert($chapo,$mp->html_encoding);
			$chapo=$mp->cleanup_html($chapo);
			
			$body=$mp->check_image($body);
			
      $body=$mp->add_attached_file_list($body);
      //$body=$mp->convert($body,$mp->html_encoding);
      //echo $body; // c'est ici qu'apparait le problme
			$body=$mp->cleanup_html($body);
			//echo $body;
			$options=$mp->convert($options,$mp->html_encoding);
			$options=$mp->html2ascii($options);
			
			#check for options
			#user
			$mail_user='';
			$mail_passwd='';
			$mail_passwd_ok=FALSE;
			foreach($user_list as $user => $id) {
				if ($mailpost_check_passwd=='yes') {
					if(preg_match("%".$user."\s+([^\s]+)%s",$options,$id_pass)) {
						$mail_user=$id;
						$mail_passwd=trim($id_pass[1]); #can be empty
            if ($blog->checkUser($id,$mail_passwd,1,TRUE)) {
							$mail_passwd_ok=TRUE;
						}
						break;
					}
				}else{
					$mail_passwd_ok=TRUE;
					if(preg_match("%".$user."%si",$options)) {
						$mail_user=$id;
						break;
					}
					if($mailpost_key!='' && preg_match('%('.$id.')\s*$%is',$mp->subject,$username)) {
						$mail_user=$id;
						$mp->subject=preg_replace('%'.$username[1].'\s*$%',"",$mp->subject);
						break;
					}
				}
			}
			
			#if not define, take the default one
			if($mail_user=='') $mail_user=$mailpost_user_id;
			
			if(!$mail_passwd_ok) echo "<h3>Le login/pass n'est pas correct pour l'insertion.</h3>";
			else echo "<h4>Le billet est post&eacute par: ".$mail_user."</h4>";     	
			$user_data=$blog->getUser($mail_user); #for default value
			
			#categorie
			$mail_cat='';
			foreach($cat_list as $cat => $id) {
				if (preg_match("%".$cat."%is",$options)) {
					$mail_cat=$id;
					break;
				}
				#or at the end of subject
				if($mailpost_key!='' && preg_match('%('.$cat.')\s*$%is',$mp->subject,$catname)) {
					$mail_cat=$id;
					$mp->subject=preg_replace('%'.$catname[1].'\s*$%',"",$mp->subject);
					break;
				}
			}
			if ($mail_cat=='') {
				$mail_cat=$user_data->arry_data[0]['user_pref_cat'];
				print "<h4>La cat&eacute;gorie est celle par defaut</h4>";
			}else{
				print "<h4>La cat&eacute;gorie est '".$cat."'</h4>";
			}
			
			#language
			$mail_language=$user_data->arry_data[0]['user_lang'];
			
			#hors ligne
			if (preg_match("%hors ligne%is",$options)) {
				$mail_hors_ligne=TRUE;
			}else{
				$mail_hors_ligne=FALSE;
			}
			if ($mail_hors_ligne) print "<h4>Ce billet a un statut hors ligne.</h4>";
			else print "<h4>Ce billet a un statut en ligne.</h4>";
			
			#key
			$mail_key=FALSE;
			if($mailpost_key=='') {
				$mail_key=TRUE;
			}else{
				if (preg_match("%".$mailpost_key."%s",$options)) {
					$mail_key=TRUE;
				}
				#or at the end of subject
				if(preg_match('%('.$mailpost_key.')\s*$%s',$mp->subject,$keyname)) {
					$mail_key=TRUE;
					$mp->subject=preg_replace('%'.$keyname[1].'\s*$%',"",$mp->subject);
				}
			}
			if (!$mail_key) print "<h3>Probleme avec la clef, erron&eacute;e ou non trouv&eacute;e</h3>";
			
			#date
			$mail_timestamp=$datemail;
			if(preg_match("%([0-9]{4})[\-:/ ]*([0-9]{2})[\-:/ ]*([0-9]{2})[\-:/ ]*([0-9]{2})[\-:/ ]*([0-9]{2})[\-:/ ]*([0-9]{2})?%s",$options, $time)) {
				if($time[6]=='') $time[6]='00'; //si pas de seconde
				$mail_timestamp=strtotime($time[1].'-'.$time[2].'-'.$time[3].' '.$time[4].':'.$time[5].':'.$time[6]);
			}
			if($mail_timestamp=='') {
				$mail_timestamp=$mp->date;
			}
			#message in futur
		
			if ($mail_timestamp>time()+300) {
        $mail_abort=TRUE;
				$mail_no_delete=TRUE;
				print "<h4>Ce message sera insere le ".date("H:i:s d/m/Y",$mail_timestamp)."</h4>";
			}else{
				print "<h4>Date d'insertion: ".date("H:i:s d/m/Y",$mail_timestamp)."</h4>";
			}
	
			print "<h4>Sujet: ".str_replace('<','&lt;',$mp->subject)."</h4>";
			
			#insert if all ok
			$post_id=FALSE;
			#$mail_abort=TRUE;  #for testing
			if (!$mail_already_inserted && !$mail_abort && $mail_key && $mail_passwd_ok) {
	# lignes ajoutes ou modifies par vincent jomain le 27/03/2006	
  $trans = array("&nbsp;" => " ");
			$chapo=strtr($chapo, $trans);
			$body=strtr($body, $trans);
		# fin des lignes ajoutes ou modifies par vincent jomain le 27/03/2006			
  			$post_id=$blog->addPost($mail_user,$mp->subject,"",$chapo,$body,$mail_md5,$mail_cat
				,'html',!$mail_hors_ligne,true,true,$mail_language);
				
				if (!$post_id) {
					print "<h3>Erreur durant l'insertion</h3>";
				}else{
					print "<h4>Billet inser&eacute;</h4>";
					#change date if needed
					if ($mail_timestamp!=$mp->date) {
						$strReq="UPDATE ".$blog->t_post." SET
							post_dt=FROM_UNIXTIME('".$mail_timestamp."'),
							post_creadt=FROM_UNIXTIME('".$mail_timestamp."'),
							post_upddt=FROM_UNIXTIME('".$mail_timestamp."')
							WHERE post_id='".$post_id."'";
						#pas grave si ca plante
						$blog->con->execute($strReq);
					}
					}
					}
			
			#if error while inserting or if not inserted => deleted link files
			#but not if already inserted
			if (!$mail_already_inserted && (!$post_id || $mail_abort || !$mail_key || !$mail_passwd_ok)) {
				if (count($mp->attached_filename)>0) {
					foreach($mp->attached_abs_filename as $filename) {
						unlink($filename);
					}
				}
				if (count($mp->inline_filename)>0) {
					foreach($mp->inline_abs_filename as $filename) {
						unlink($filename);
					}
				}
			}
			# lignes ajoutes ou modifies par vincent jomain le 14/03/2006
        $mail_abort=FALSE; // sans cette ligne, si un billet tait  poster 
        //plus tard ou si la structure d'un billet n'tait pas conforme
        //les billets suivants copaient du mme status. 
  # fin des lignes ajoutes ou modifies par vincent jomain le 14/03/2006
			
			#delete mail
			if (!$mail_no_delete && $mailpost_delete_message=='yes') {
				$lk_mail -> delete($mail_id);
			}
			
			/*
			#display some info
			if($chapo!='') {
				echo '<hr\>';
				echo $chapo;
			}
			echo '<hr\>';
			echo $body;
			echo "<hr\>";
			*/
			/*
			$vars=get_defined_vars();
			foreach($vars as $name => $value) {
				if(preg_match("%^mail%",$name)) {
					echo "<br\><b>".$name."</b><br\>";
					print_r($value);
				}
			}
			*/
			
		}
	}
	$lk_mail -> close();
	echo "<h3>That's all folks !</h3>";
}

/*$vars=get_defined_constants();
foreach($vars as $name => $value) {
	if(preg_match("%^dc%",$name)) {
		echo "<br\><b>".$name."</b><br\>";
		print_r($value);
	}
}*/

echo $lk_mail -> errors;

?>
