<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#eze
# ***** END LICENSE BLOCK *****
#
# Contributor : Aurelien ANTOINE (http://ilpleut.be/)
#
# connection class with imap extension // manipulate mail box

class ConnectionImap {
	
	var $mbox;
	var $server;
	var $protocol;
	var $login;
	var $passwd;
	var $errors;
	
	var $ids=array();
	
	function ConnectionImap($server,$protocol,$login,$passwd) {
		$this->server=$server;
		$this->protocol=$protocol;
		$this->login=$login;
		$this->passwd=$passwd;
	}
	
	function connect() {
		if (! $this->mbox = @imap_open ("{".$this->server.$this->protocol , $this->login, $this->passwd)) {
			$this->errors.="verifier le login et le mot de passe";
			return FALSE;
		}
		return TRUE;
	}
	
	function display_error() {
		$this->errors.=implode('<br/>',array_merge(imap_alerts(),imap_errors()));
		return ($this->errors);
	}
	
	function close() {
		if(! @imap_expunge($this->mbox)) {
			return FALSE;
		}
		if (! imap_close($this->mbox)) {
			return FALSE;
		}
		return TRUE;
	}
	
	function get_ids() {
		$mail_array = imap_headers ( $this->mbox );
		$msg_id=array();
		$this->ids=array();
		if(count($mail_array)>0) {
			foreach($mail_array as $mail){
				if(preg_match("%^N? +([0-9]+)%", $mail, $msg_id )) {
					array_push($this->ids,$msg_id[1]);
				}
			}
		}
		return (count($this->ids));
	}
	
	function delete($id) {
		if(imap_delete ($this->mbox, $id)) {
			return TRUE;
		}
		return FALSE;
	}
	
	function get($id) {
		return (imap_fetchheader($this->mbox, $id).imap_body($this->mbox, $id));
	}
}
?>
