<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#eze
# ***** END LICENSE BLOCK *****
#
# Contributor : Aurelien ANTOINE (http://ilpleut.be/)
#

include_once(dirname(__FILE__)."/inc/class.tools.php");

$plug_name='mailpost';

buffer::str('<h2>'.__('MailPost').'</h2>');

//check and prepare the share directory for mailpost
$config_filename=DC_SHARE_DIR."/mailpost/config.php";

if (!file_exists($config_filename)) {

	if( !file_exists(dirname($config_filename)) && ! @mkdir(dirname($config_filename),0777)) {
		buffer::str("<h3>".__("cannot create mailpost share")."</h3>");
	}
	if ($fp = @fopen(dirname($config_filename)."/.htaccess", "w")) {
		fwrite($fp,"Deny from all\n");
		fclose($fp);
		@chmod(dirname($config_filename)."/.htaccess", 0644);
		if ($fp = @fopen($config_filename, "w")) {
			$data= 	'<?php'."\r\n".
				'$mailpost_server=\'pop.server.com\''.";\r\n".
				'$mailpost_delete_message=\'yes\''.";\r\n".
				'$mailpost_img_rel_path=\''.dc_img_url.'mailpost/\''.";\r\n".
				'$mailpost_check_passwd=\'no\''.";\r\n".
				'$mailpost_load_dotclear=\'no\''.";\r\n".
				'$mailpost_chapo_body="%FIN CHAPO%"'.";\r\n".
				'$mailpost_body_config="%FIN BILLET%"'.";\r\n".
				"?".">";
			fwrite($fp,$data);
			fclose($fp);
			@chmod($config_filename, 0777);
		}
	}else{
		buffer::str("<h3>".__("cannot write in share directory")."</h3>");
	}
}

//save post data if any
if($_POST['post_check_passwd']!='') {

	$fileptr = fopen ( $config_filename , 'w');
	if (! $fileptr) {
		buffer::str('<h3>'.__('error open file').'</h3>');
	}else{
		//check pass & repass
		if ($_POST['post_passwd']!=$_POST['post_repasswd']) {
			$_POST['post_passwd']='';
			buffer::str('<h3>'.__('error paswd').'</h3>');
		}
		//check key
		$_POST['post_key']=preg_replace("%^\s*([^\s]+).*$%","\\1",$_POST['post_key']);
		//config file
		$_POST['post_path']=ereg_replace("/+","/",$_POST['post_path']."/");
		$img_root=str_replace(dc_img_url,$_POST['post_path'],dc_img_root);
		$img_root=ereg_replace("/+","/",$img_root);
		$data=  "<?php\r\n".
			'$mailpost_server=\''.$_POST['post_server']."';\r\n".
			'$mailpost_protocol=\''.$_POST['post_protocol']."';\r\n".
			'$mailpost_login=\''.$_POST['post_login']."';\r\n".
			'$mailpost_passwd=\''.$_POST['post_passwd']."';\r\n".
			'$mailpost_delete_message=\''.$_POST['post_delete_message']."';\r\n".
			'$mailpost_img_rel_path=\''.$_POST['post_path']."';\r\n".
			'$mailpost_user_id=\''.$_POST['post_user_id']."';\r\n".
			'$mailpost_check_passwd=\''.$_POST['post_check_passwd']."';\r\n".
			'$mailpost_img_path=\''.$img_root."';\r\n".
			'$mailpost_load_dotclear=\''.$_POST['post_load_dotclear']."';\r\n".
			'$mailpost_key=\''.$_POST['post_key']."';\r\n".
			'$mailpost_chapo_body=\''.$_POST['post_chapo_body']."';\r\n".
			'$mailpost_body_config=\''.$_POST['post_body_config']."';\r\n".
			"?".">";
		if (! fwrite ( $fileptr, $data )) {
			buffer::str('<h3>'.__('error writing').'</h3>');
		}
		fclose($fileptr);
		
	}
}

//load server data
if (file_exists($config_filename)) {
	include($config_filename);
}

//connection type (with and without imap)
if (extension_loaded ('imap')) {
	$list_protocol=array(
		"soft"			=> __("POP3 port:110 with internal library"),
		":110/pop3/notls}INBOX" => __("POP3 port:110 with IMAP library") ,
		":995/pop3/ssl/novalidate-cert}INBOX" => __("POP3 SSL port:995 with IMAP library") ,
		":143/imap/notls}INBOX" => __("IMAP port 143 in INBOX with IMAP library") ,
		":993/imap/ssl}INBOX" => __("IMAP SSL port 993 in INBOX with IMAP library") ,
	);
}else{
	$list_protocol=array(
		"soft"			=> __("POP3 port:110 with internal library"),
	);
}

//take user list
$users=$blog->getUser();
foreach($users->arry_data as $user) {
	$user_list[]=$user['user_id'];
}

buffer::str('
	<a name="config"></a>
	<fieldset class="clear"><legend>'.__('mailpost data').'</legend><p>
	<h3>'.__('mail config detail').'</h3>
	<form action="#config" method="post"><table>
	<tr><td>'.__('server').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'server').'</td><td><input type="text" name="post_server" value="'.$mailpost_server.'"/></td></tr>
	<tr><td>'.__('protocol').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'protocol').'</td><td>
	<select name="post_protocol">');
	
foreach($list_protocol as $prot => $name) {
	buffer::str('<option value="'.$prot.'" '.(($mailpost_protocol==$prot)?'selected':'').' >'.$name.'</option>');
}

buffer::str('
	</select>
	</td></tr>
	<tr><td>'.__('login').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'login').'</td><td><input type="text" name="post_login" value="'.$mailpost_login.'"/></td></tr>
	<tr><td>'.__('passwd').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'passwd').'</td><td><input type="password" name="post_passwd" SIZE="20" value="'.$mailpost_passwd.'"/></td></tr>
	<tr><td>'.__('repasswd').'</td><td><input type="password" name="post_repasswd" SIZE="21" value="'.$mailpost_passwd.'"/></td></tr>
	<tr><td>'.__('delete_message').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'delete').'</td><td>
	<select name="post_delete_message">
		<option value="no" '.(($mailpost_delete_message=="no")?'selected':'').' >'.__('no').'</option>
		<option value="yes" '.(($mailpost_delete_message=="yes")?'selected':'').' >'.__('yes').'</option>
	</select>
	</td></tr></table>
	<h3>'.__('MailPost detail').'</h3><table>
	<tr><td>'.__('path').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'path').'</td><td><input type="text" name="post_path" value="'.$mailpost_img_rel_path.'"/></td></tr>
	<tr><td>'.__('default user').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'default_user').'</td><td>
	<select name="post_user_id">
');
	
foreach($user_list as $user) {
	buffer::str('<option value="'.$user.'" '.(($user==$mailpost_user_id)?'selected':'').' >'.$user.'</option>');
}

buffer::str('
	</select>
	</td></tr>
	<tr><td>'.__('key').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'key').'</td><td><input type="text" name="post_key" SIZE="20" value="'.$mailpost_key.'"/></td></tr>
	<tr><td>'.__('check passwd').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'check_passwd').'</td><td>
	<select name="post_check_passwd">
		<option value="yes" '.(($mailpost_check_passwd=="yes")?'selected':'').' >'.__('yes').'</option>
		<option value="no" '.(($mailpost_check_passwd=="no")?'selected':'').' >'.__('no').'</option>
	</select>
	</td></tr>
	<tr><td>'.__('chapo_body').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'chapo_body').'</td><td>
	<select name="post_chapo_body">
		<!-- lignes ajoutes ou modifies par vincent jomain le 14/03/2006-->
		<option value="%\={5,}\s*%" '.(($mailpost_chapo_body=="%\={5,}%")?'selected':'').'>'.__('egal').'</option>
		<!-- fin des lignes ajoutes ou modifies par vincent jomain le 14/03/2006
		Cela vite le retour  la ligne obligatoire
    <option value="%\={5,}\s*<br />%" '.(($mailpost_chapo_body=="%\={5,}%")?'selected':'').'>'.__('egal').'</option>  -->  
		<option value="%FIN CHAPO%" '.(($mailpost_chapo_body=="%FIN CHAPO%")?'selected':'').'>'.__('finchapo').'</option>
		<option value="%\-FC\-%" '.(($mailpost_chapo_body=="%\-FC\-%")?'selected':'').'>'.__('fc').'</option>
	</select>
	</td></tr>
	<tr><td>'.__('body_config').'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'body_config').'</td><td>
	<select name="post_body_config">
		<!-- lignes ajoutes ou modifies par vincent jomain le 14/03/2006-->
		<option value="%\-{5,}\s*%" '.(($mailpost_body_config=="%\-{5,}%")?'selected':'').'>'.__('tirets').'</option>
		<!-- fin des lignes ajoutes ou modifies par vincent jomain le 14/03/2006
    Cela vite le retour  la ligne obligatoire
    <option value="%\-{5,}\s*<br />%" '.(($mailpost_body_config=="%\-{5,}\s*<br />%")?'selected':'').'>'.__('tirets').'</option>-->
		<option value="%FIN BILLET%" '.(($mailpost_body_config=="%FIN BILLET%")?'selected':'').'>'.__('finbillet').'</option>
		<option value="%\-FB\-%" '.(($mailpost_body_config=="%\-FB\-%")?'selected':'').'>'.__('fb').'</option>
	</select>
	</td></tr>
	<tr><td>'.__("download via dotclear").'&nbsp;'.helpLink('index&amp;plugin='.$plug_name,'via_dotclear').'</td>
	<td>
	<select name="post_load_dotclear">
		<!--<option value="yes" '.(($mailpost_load_dotclear=="yes")?'selected':'').' >'.__('yes').'</option>-->
		<option value="no" '.(($mailpost_load_dotclear=="no")?'selected':'').' >'.__('no').'</option>
	</select>
	</td></tr>
	<tr><td><br/><INPUT TYPE="submit" name="update" VALUE="'.__('submit').'"/></td></tr>
	</table></form>
	</p></fieldset>
');

//check pop3 status

if($check_pop!='') {
	$popmsg='';
	#check mail path
	if (is_writable($mailpost_img_path)) {
		$popmsg.="<h4>".__("path ok")."</h4>";
	}else{
		$popmsg.="<h3>".__("path ko")."(".$path.")</h3>";
	}
	
	#check mail stuff
	if ($mailpost_protocol=='soft') {
		include dirname(__FILE__)."/inc/class.mail.soft.php";
		$mail_con= new ConnectionSoft($mailpost_server,$mailpost_protocol,$mailpost_login,$mailpost_passwd);
	}else{
		include dirname(__FILE__)."/inc/class.mail.imap.php";
		$mail_con= new ConnectionImap($mailpost_server,$mailpost_protocol,$mailpost_login,$mailpost_passwd);
	}
	
	if (!$mail_con->connect()) {
		$popmsg.="<h3>".__("error mail config")."</h3>";
		$popmsg.="<h4>".$mail_con->display_error()."</h4>";
	}else{
		$nbr_message=$mail_con->get_ids();
		$popmsg.="<h4>".__("mail ok")." ".$nbr_message." ".__("mail ok next")."</h4>";
		$mail_con->close();
	}
}

// display status
buffer::str('<a name="statut"></a><fieldset class="clear"><legend>'.__('mailpost status').'</legend><p><h3>');
if( $popmsg=='') {
	buffer::str('
		<form action="#statut" method="post">
		<input type="submit" name="check_pop" value="'.__('check mail config').'"/>
		</form>
	');
}else{
	buffer::str($popmsg);
}
buffer::str('</h3></p></fieldset>');

$downloadurl=$_SERVER['SERVER_NAME'].dc_app_url."/".DC_ECRIRE."/tools/mailpost/downloadmail.php";
$downloadurl='http://'.ereg_replace("/+","/",$downloadurl);

buffer::str('<fieldset class="clear"><legend>'.__('mailpost run').'</legend>');
buffer::str(__('explanation').'<ul>');
buffer::str('<li>'.__('ex2-1').'<br/>');
buffer::str('<i><a href="'.$downloadurl.'" target="_BLANK">'.$downloadurl.'</a></i></li>');
buffer::str('<li>'.__('ex3-1').'<br/>');
buffer::str('<i>0,30 * * * * wget -q -O /dev/null '.$downloadurl.'</i><br/>');
buffer::str(__('ex3-2').'</li>');
buffer::str('<li>'.__('ex1-1').'</li>');
buffer::str('</ul></fieldset>');

buffer::str('<fieldset class="clear"><legend>'.__('struct options').'</legend>');
buffer::str(l10n::getHtmlFile(dirname(__FILE__).'/help/','struct.html',DC_LANG,dc_encoding));
buffer::str('</fieldset>');


?>
